#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def point_milieu_(f,a,b,n):
    h=(b-a)/(n+1)
    s=0
    for k in range(n):
        s=s+h*f(a+h*(k+0.5))
    return s

def point_milieu(f,a,b,n):
    h=(b-a)/(n+1)
    s=0
    xk=a
    for k in range(n):
        s=s+h*f(xk+h/2) 
        xk=xk+h
    return s


def exo1(x):
    return x

def exo2(x):
    return x**2

def exo3(x):
    return np.exp(np.sin(x))/x**(8/9)


I=point_milieu(np.cos,-np.pi/2,np.pi/2,100)
print(I)
    
I=point_milieu(np.sin,0,np.pi,100)
print(I)

I=point_milieu(exo1,0,np.sqrt(2),500)
print(np.abs(I-1))

I=point_milieu(exo2,0,3,2000)
print(np.abs(I-9))


I=point_milieu(exo3,0,1,1000000)
print(I)
